LeetCode题1. 两数之和

it2025-04-04  2

题目描述: 给定一个整数数组 nums 和一个目标值 target,请你在该数组中找出和为目标值的那 两个 整数,并返回他们的数组下标。你可以假设每种输入只会对应一个答案。但是,数组中同一个元素不能使用两遍。 例子: 给定 nums = [2, 7, 11, 15], target = 9 因为 nums[0] + nums[1] = 2 + 7 = 9 所以返回 [0, 1] 思路: 1.双层for循环遍历nums数组,判断相同则返回下标 2.降低时间复杂度。使用hashtable优化 class Solution { public int[] twoSum(int[] nums, int target) { int[] index = new int[2] ; for(int i = 0 ; i < nums.length ; i++){ for(int j = i + 1 ; j < nums.length ; j++){ if((nums[i] + nums[j]) == target){ index[0] = i ; index[1] = j ; break ; } } } return index ; } } class Solution { public int[] twoSum(int[] nums, int target) { Map<Integer,Integer> table = new HashMap<Integer,Integer>() ; for(int i = 0 ; i < nums.length ; i++){ if(table.containsKey(target - nums[i])){ return new int[]{table.get(target - nums[i]) ,i} ; } table.put(nums[i] , i) ; } return new int[0] ; } }
最新回复(0)